/****************************************************************************
 ****************************************************************************
 *
 * export.c
 *
 ****************************************************************************
 ****************************************************************************/





#include <stdio.h>

#include "export.h"
#include "error.h"
#include "debug.h"
#include "verbose.h"



/****************************************************************************
 * export_ushort_be
 ****************************************************************************/
unsigned char *
export_ushort_be(
	unsigned char			*data,
	int				val)

	{
	data[0] = (val >> 8) & 0xff;
	data[1] = val & 0xff;
	return (data);
	}



/****************************************************************************
 * export_ushort_le
 ****************************************************************************/
unsigned char *
export_ushort_le(
	unsigned char			*data,
	int				val)

	{
	data[0] = val & 0xff;
	data[1] = (val >> 8) & 0xff;
	return (data);
	}



/****************************************************************************
 * export_ulong_le
 ****************************************************************************/
unsigned char *
export_ulong_le(
	unsigned char			*data,
	unsigned long			val)

	{
	data[0] = val & 0xff;
	data[1] = (val >> 8) & 0xff;
	data[2] = (val >> 16) & 0xff;
	data[3] = (val >> 24) & 0xff;
	return (data);
	}
/******************************************************** Karsten Scheibler */
